-- Function: department.data_users_create(text, text, text, text, text)

-- DROP FUNCTION department.data_users_create(text, text, text, text, text);

CREATE OR REPLACE FUNCTION department.data_users_create(f_user_name text, user_phone text, user_mail text, user_alias text, user_password text)
  RETURNS user_row AS
$BODY$DECLARE
user_alias_id integer;
t_user_row user_row;
BEGIN
IF ((SELECT COUNT(*) FROM department.data_users WHERE user_name=f_user_name)>0)
  THEN RAISE EXCEPTION
    '% ya existe',f_user_name;
ELSIF ((SELECT COUNT(*) FROM department.data_users_alias WHERE aliasname=user_alias)>0)
  THEN RAISE EXCEPTION
    '% como alias ya existe',user_alias;
ELSE
  INSERT INTO department.data_users_alias (aliasname,aliaspassword) VALUES (user_alias,user_password);
  user_alias_id=(SELECT id FROM department.data_users_alias WHERE aliasname=user_alias);
  INSERT INTO department.data_users (user_name,phone,mail,alias_id,department_id,rol_id) VALUES (f_user_name,user_phone,user_mail,user_alias_id,0,2);
  t_user_row.t_user_name = f_user_name;
  t_user_row.t_phone = user_phone;
  t_user_row.t_mail = user_mail;
  t_user_row.t_alias = user_alias;
  t_user_row.t_rol = (SELECT rol_name FROM  department.data_users_rol WHERE id = 2);
  t_user_row.t_department = (SELECT dept_name FROM department.department_names WHERE id = 0);
  RETURN t_user_row;
END IF;
RETURN NULL;
END;$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION department.data_users_create(text, text, text, text, text) OWNER TO netmanager;
-- Function: department.data_users_select(text, text)

-- DROP FUNCTION department.data_users_select(text, text);

CREATE OR REPLACE FUNCTION department.data_users_select(f_rol text, f_dept text)
  RETURNS SETOF user_row_view AS
$BODY$
DECLARE
	t_user_row user_row_view;
BEGIN
IF (f_rol <> 'ADMIN')
THEN
  FOR t_user_row IN SELECT user_name FROM department.data_users_view WHERE rol_name <> 'ADMIN' AND (dept_name=f_dept OR dept_name='Ninguno')
  LOOP
    t_user_row.t_phone=(SELECT phone FROM department.data_users_view WHERE user_name=t_user_row.t_user_name);
    t_user_row.t_mail=(SELECT mail FROM department.data_users_view WHERE user_name=t_user_row.t_user_name);
    t_user_row.t_rol=(SELECT rol_name FROM department.data_users_view WHERE user_name=t_user_row.t_user_name);
    t_user_row.t_department=(SELECT dept_name FROM department.data_users_view WHERE user_name=t_user_row.t_user_name);
    RETURN NEXT t_user_row;
  END LOOP;
ELSE
  FOR t_user_row IN SELECT user_name FROM department.data_users_view
  LOOP
    t_user_row.t_phone=(SELECT phone FROM department.data_users_view WHERE user_name=t_user_row.t_user_name);
    t_user_row.t_mail=(SELECT mail FROM department.data_users_view WHERE user_name=t_user_row.t_user_name);
    t_user_row.t_rol=(SELECT rol_name FROM department.data_users_view WHERE user_name=t_user_row.t_user_name);
    t_user_row.t_department=(SELECT dept_name FROM department.data_users_view WHERE user_name=t_user_row.t_user_name);
    RETURN NEXT t_user_row;
  END LOOP;
END IF;

END;$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION department.data_users_select(text, text) OWNER TO netmanager;
-- Function: department.data_users_update(text, text, text, text, text, text)

-- DROP FUNCTION department.data_users_update(text, text, text, text, text, text);

CREATE OR REPLACE FUNCTION department.data_users_update(user_phone text, user_mail text, user_alias text, user_password text, user_dept text, user_rol text)
  RETURNS integer AS
$BODY$DECLARE
user_alias_id integer;
user_dept_id integer;
user_rol_id integer;
BEGIN
IF ((SELECT COUNT(*) FROM department.data_users_alias WHERE user_alias=aliasname)<>1)
  THEN RAISE EXCEPTION
    '% no existe como alias.',aliasname;
ELSE
  user_alias_id=(SELECT id FROM department.data_users_alias WHERE aliasname=user_alias);
  user_dept_id=(SELECT id FROM department.department_names WHERE dept_name=user_dept);
  user_rol_id=(SELECT id FROM department.data_users_rol WHERE rol_name= user_rol);
  UPDATE department.data_users_alias SET aliaspassword=user_password WHERE id=user_alias_id;
  UPDATE department.data_users SET phone=user_phone,mail=user_mail,department_id=user_dept_id,rol_id=user_rol_id WHERE alias_id=user_alias_id;
  RETURN 0;
END IF;
RETURN -1;
END;$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION department.data_users_update(text, text, text, text, text, text) OWNER TO netmanager;
-- Function: department.data_users_validatelogon(text, text)

-- DROP FUNCTION department.data_users_validatelogon(text, text);

CREATE OR REPLACE FUNCTION department.data_users_validatelogon(user_alias text, user_password text)
  RETURNS user_row AS
$BODY$DECLARE
userpass text;
t_user_row user_row;
BEGIN
userpass = (SELECT aliaspassword FROM department.data_users_alias WHERE aliasname = user_alias);
IF (userpass = user_password)
THEN
	t_user_row.t_alias=user_alias;
	t_user_row.t_phone=(SELECT phone FROM department.data_users_view WHERE aliasname = user_alias);
	t_user_row.t_mail=(SELECT mail FROM department.data_users_view WHERE aliasname = user_alias);
	t_user_row.t_rol=(SELECT rol_name FROM department.data_users_view WHERE aliasname = user_alias);
	t_user_row.t_department=(SELECT dept_name FROM department.data_users_view WHERE aliasname = user_alias);
	t_user_row.t_user_name=(SELECT user_name FROM department.data_users_view WHERE aliasname = user_alias);
	RETURN t_user_row;
ELSE
	RETURN NULL;
END IF;
END;$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION department.data_users_validatelogon(text, text) OWNER TO netmanager;
-- Function: department.departments_name_select()

-- DROP FUNCTION department.departments_name_select();

CREATE OR REPLACE FUNCTION department.departments_name_select()
  RETURNS SETOF text AS
$BODY$
DECLARE
	d_dept_name text;
BEGIN
FOR d_dept_name IN SELECT dept_name FROM department.department_names_view
LOOP
	RETURN NEXT d_dept_name;
END LOOP;
END;$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION department.departments_name_select() OWNER TO netmanager;
-- Function: department.departments_name_select(text)

-- DROP FUNCTION department.departments_name_select(text);

CREATE OR REPLACE FUNCTION department.departments_name_select(f_dept text)
  RETURNS SETOF text AS
$BODY$
DECLARE
	d_dept_name text;
BEGIN
FOR d_dept_name IN SELECT dept_name FROM department.department_names_view WHERE dept_name=f_dept OR dept_name='Ninguno'
LOOP
	RETURN NEXT d_dept_name;
END LOOP;
END;$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION department.departments_name_select(text) OWNER TO netmanager;

-- Function: department.data_users_update_rol_dept(text, text, text)

-- DROP FUNCTION department.data_users_update_rol_dept(text, text, text);

CREATE OR REPLACE FUNCTION department.data_users_update_rol_dept(user_name_ text, user_dept text, user_rol text)
  RETURNS integer AS
$BODY$DECLARE
user_alias_id integer;
user_dept_id integer;
user_rol_id integer;
BEGIN
IF ((SELECT COUNT(*) FROM department.data_users WHERE user_name=user_name_)<>1)
  THEN RAISE EXCEPTION
    '% no existe como alias.',user_name_;
ELSE
  user_dept_id=(SELECT id FROM department.department_names WHERE dept_name=user_dept);
  user_rol_id=(SELECT id FROM department.data_users_rol WHERE rol_name= user_rol);
  UPDATE department.data_users SET department_id=user_dept_id,rol_id=user_rol_id WHERE user_name=user_name_;
  RETURN 0;
END IF;
RETURN -1;
END;$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION department.data_users_update_rol_dept(text, text, text) OWNER TO netmanager;
-- Function: hostmng.hosts_exists(text)

-- DROP FUNCTION hostmng.hosts_exists(text);

CREATE OR REPLACE FUNCTION hostmng.hosts_exists(hostname_ text)
  RETURNS integer AS
$BODY$BEGIN
IF ((SELECT COUNT(*) FROM hostmng.hosts WHERE hostname=hostname_)=0)
THEN
	RETURN 0;
ELSE
	RETURN 1;
END IF;
END;$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION hostmng.hosts_exists(text) OWNER TO netmanager;


-- Function: hostmng.hosts_create(text, text, text, text, text)

-- DROP FUNCTION hostmng.hosts_create(text, text, text, text, text);

CREATE OR REPLACE FUNCTION hostmng.hosts_create(hostname_ text, ip_ text, finalidad_ text, tipo_ text, dept_ text)
  RETURNS integer AS
$BODY$DECLARE
tipo_d integer;
dept_d integer;
BEGIN
IF (hostmng.hosts_exists(hostname_)=1)
THEN
	RETURN -1;
ELSE
	tipo_d=(SELECT id FROM hostmng.host_type WHERE typename=tipo_);
	dept_d=(SELECT id FROM department.department_names WHERE dept_name=dept_);
	INSERT INTO hostmng.hosts(
            hostname, ip, finalidad, tipo, dept_id)
	VALUES (hostname_, ip_, finalidad_, tipo_d, dept_d);
	RETURN 0;
END IF;
END;$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION hostmng.hosts_create(text, text, text, text, text) OWNER TO netmanager;


-- Function: hostmng.hosts_update(text, text, text, text, text)

-- DROP FUNCTION hostmng.hosts_update(text, text, text, text, text);

CREATE OR REPLACE FUNCTION hostmng.hosts_update(hostname_ text, ip_ text, finalidad_ text, tipo_ text, dept_ text)
  RETURNS integer AS
$BODY$DECLARE
tipo_d integer;
dept_d integer;
BEGIN
IF (hostmng.hosts_exists(hostname_)=1)
THEN
	tipo_d=(SELECT id FROM hostmng.host_type WHERE typename=tipo_);
	dept_d=(SELECT id FROM department.department_names WHERE dept_name=dept_);
	UPDATE hostmng.hosts SET ip=ip_, finalidad=finalidad_, tipo=tipo_d, dept_id=dept_d
		WHERE hostname=hostname_;
	RETURN 0;
ELSE
	RETURN-1;
END IF;
END;$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION hostmng.hosts_update(text, text, text, text, text) OWNER TO netmanager;