-- Table: department.department_names

-- DROP TABLE department.department_names;

CREATE TABLE department.department_names
(
  id serial NOT NULL,
  dept_name text NOT NULL,
  CONSTRAINT department_pk PRIMARY KEY (dept_name),
  CONSTRAINT deparment_unique UNIQUE (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE department.department_names OWNER TO netmanager;

-- Table: department.data_users_basic

-- DROP TABLE department.data_users_basic;

CREATE TABLE department.data_users_basic
(
  id serial NOT NULL,
  user_name text NOT NULL,
  phone text NOT NULL,
  mail text NOT NULL,
  CONSTRAINT users_basic_pk PRIMARY KEY (user_name),
  CONSTRAINT users_basic_unique_id UNIQUE (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE department.data_users_basic OWNER TO netmanager;
-- Table: department.data_users_rol

-- DROP TABLE department.data_users_rol;

CREATE TABLE department.data_users_rol
(
  id serial NOT NULL,
  rol_name text NOT NULL,
  CONSTRAINT privileges_pk PRIMARY KEY (rol_name),
  CONSTRAINT privilege_unique_id UNIQUE (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE department.data_users_rol OWNER TO netmanager;
-- Table: department.data_users_alias

-- DROP TABLE department.data_users_alias;

CREATE TABLE department.data_users_alias
(
  id serial NOT NULL,
  aliasname text NOT NULL,
  aliaspassword text NOT NULL,
  CONSTRAINT alias_pk PRIMARY KEY (aliasname),
  CONSTRAINT alias_unique_id UNIQUE (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE department.data_users_alias OWNER TO netmanager;
-- Table: department.data_users

-- DROP TABLE department.data_users;

CREATE TABLE department.data_users
(
-- Heredado from table department.data_users:  id integer NOT NULL DEFAULT nextval('department.data_users_basic_id_seq'::regclass),
-- Heredado from table department.data_users:  user_name text NOT NULL,
-- Heredado from table department.data_users:  phone text NOT NULL,
-- Heredado from table department.data_users:  mail text NOT NULL,
  rol_id integer NOT NULL,
  alias_id integer NOT NULL DEFAULT 4,
  department_id integer,
  CONSTRAINT users_alias_fk FOREIGN KEY (alias_id)
      REFERENCES department.data_users_alias (id) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT users_department_fk FOREIGN KEY (department_id)
      REFERENCES department.department_names (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT users_rol_fk FOREIGN KEY (rol_id)
      REFERENCES department.data_users_rol (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
INHERITS (department.data_users_basic)
WITH (
  OIDS=FALSE
);
ALTER TABLE department.data_users OWNER TO netmanager;

-- Table: hostmng.host_type

-- DROP TABLE hostmng.host_type;

CREATE TABLE hostmng.host_type
(
  id serial NOT NULL,
  typename text NOT NULL,
  CONSTRAINT host_type_pk PRIMARY KEY (typename),
  CONSTRAINT host_type_unique_id UNIQUE (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE hostmng.host_type OWNER TO netmanager;

-- Table: hostmng.hosts

-- DROP TABLE hostmng.hosts;

CREATE TABLE hostmng.hosts
(
  id serial NOT NULL,
  hostname text NOT NULL,
  ip text,
  finalidad text,
  tipo integer,
  dept_id integer,
  CONSTRAINT hosts_pk PRIMARY KEY (hostname),
  CONSTRAINT hosts_dept_fk FOREIGN KEY (dept_id)
      REFERENCES department.department_names (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT hosts_fk FOREIGN KEY (tipo)
      REFERENCES hostmng.host_type (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT hosts_unique_id UNIQUE (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE hostmng.hosts OWNER TO netmanager;

