-- View: department.data_users_view

-- DROP VIEW department.data_users_view;

CREATE OR REPLACE VIEW department.data_users_view AS 
 SELECT p.id, p.user_name, q.aliasname, q.aliaspassword, r.rol_name, s.dept_name, p.phone, p.mail
   FROM department.data_users p
   JOIN department.data_users_alias q ON p.alias_id = q.id
   JOIN department.data_users_rol r ON p.rol_id = r.id
   JOIN department.department_names s ON p.department_id = s.id;

ALTER TABLE department.data_users_view OWNER TO netmanager;

-- View: department.data_users_view_manager

-- DROP VIEW department.data_users_view_manager;

CREATE OR REPLACE VIEW department.data_users_view_manager AS 
 SELECT data_users_view.id, data_users_view.user_name, data_users_view.aliasname, data_users_view.rol_name, data_users_view.dept_name, data_users_view.phone, data_users_view.mail
   FROM department.data_users_view
  WHERE data_users_view.rol_name <> 'ADMIN'::text;

ALTER TABLE department.data_users_view_manager OWNER TO netmanager;

-- View: department.department_names_view

-- DROP VIEW department.department_names_view;

CREATE OR REPLACE VIEW department.department_names_view AS 
 SELECT department_names.id, department_names.dept_name
   FROM department.department_names
  WHERE department_names.dept_name <> 'Todos'::text AND department_names.dept_name <> 'Ninguno'::text
  ORDER BY department_names.dept_name;

ALTER TABLE department.department_names_view OWNER TO netmanager;

-- Table: hostmng.hosts

-- DROP TABLE hostmng.hosts;

CREATE TABLE hostmng.hosts
(
  id serial NOT NULL,
  hostname text NOT NULL,
  ip text,
  tipo text,
  CONSTRAINT hosts_pk PRIMARY KEY (hostname),
  CONSTRAINT hosts_unique_id UNIQUE (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE hostmng.hosts OWNER TO netmanager;

-- View: hostmng.hosts_view

-- DROP VIEW hostmng.hosts_view;

CREATE OR REPLACE VIEW hostmng.hosts_view AS 
 SELECT p.hostname, p.ip, p.finalidad, q.typename, r.dept_name
   FROM hostmng.hosts p
   JOIN hostmng.host_type q ON q.id = p.tipo
   JOIN department.department_names r ON r.id = p.dept_id;

ALTER TABLE hostmng.hosts_view OWNER TO netmanager;

-- View: hostmng.hosts_view_main

-- DROP VIEW hostmng.hosts_view_main;

CREATE OR REPLACE VIEW hostmng.hosts_view_main AS 
 SELECT hosts_view.hostname AS nombre_maquina, hosts_view.ip, hosts_view.finalidad, hosts_view.typename AS tipo, hosts_view.dept_name AS departamento
   FROM hostmng.hosts_view;

ALTER TABLE hostmng.hosts_view_main OWNER TO netmanager;

-- View: hostmng.hosts_view_main_user

-- DROP VIEW hostmng.hosts_view_main_user;

CREATE OR REPLACE VIEW hostmng.hosts_view_main_user AS 
 SELECT hosts_view.hostname AS nombre_maquina, hosts_view.ip, hosts_view.finalidad, hosts_view.typename AS tipo, hosts_view.dept_name AS departamento
   FROM hostmng.hosts_view
  WHERE hosts_view.typename = 'Virtual'::text;

ALTER TABLE hostmng.hosts_view_main_user OWNER TO netmanager;